if (window.JeeWeb == 'undefined' || window.JeeWeb == null) {
    console.log(" JeeWeb: create ");
    window.JeeWeb = {};
}


// 发送命令
JeeWeb.command = function (object, callback) {
    const k = JeeWebSDK.uuid();
    const payloadString = JSON.stringify(object);
    JeeWebSDK.FUNCTION_MAP.set(k, callback);
    JeeWebSDK.command(k, payloadString);
}

JeeWeb.onReceive = function (callback) {
    const k = JeeWebSDK.uuid();

    console.log(" onReceive: " + k + ",  callback " + callback);
    JeeWebSDK.FUNCTION_MAP.set(k, callback);
    console.log(JeeWebSDK.FUNCTION_MAP.size + " onReceive: " + JeeWebSDK.FUNCTION_MAP.get(k));
    JeeWebSDK.onReceive(k);
}


// 获取用户信息 TODO 后期可能加授权
JeeWeb.getAppInfo = function (callback) {
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    JeeWebSDK.getAppInfo(uuid);
}


JeeWeb.getUserProfile = function (callback) {
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    JeeWebSDK.getUserProfile(uuid);
}


JeeWeb.showSelectDevicePage = function (callback) {
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    JeeWebSDK.showSelectDevicePage(uuid);
}

//-----K-V存储------
JeeWeb.getLocal = function (key, callback) {
    const fn = function (res) {
        const result = res.result;
        if (result) {
            try {
                const parsedObject = JSON.parse(result);
                res.result = parsedObject;
            } catch (error) {
                JeeWebSDK.log(error);
            }
        }
        callback(res);
    }

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, fn);
    const payload = { 'key': key };

    JeeWebSDK.getLocal(uuid, JSON.stringify(payload));

}

JeeWeb.setLocal = function (key, value, callback) {


    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    let stringValue = JSON.stringify(value);
    const payload = { 'key': key, 'value': stringValue };

    JeeWebSDK.setLocal(uuid, JSON.stringify(payload));
}

JeeWeb.getAllLocal = function(callback) {
    const fn = function(res) {
        const result = res.result;
        if (result) {
            const parsedObject = {};
            for (const key in result) {
                if (result.hasOwnProperty(key)) {
                    try {
                        parsedObject[key] = JSON.parse(result[key]);
                    } catch (error) {
                        JeeWebSDK.log(error);
                    }
                }
            }
            res.result = parsedObject;
        }
        callback(res);
    }
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);

    JeeWebSDK.getAllLocal(uuid);
}

JeeWeb.removeLocal = function (key, callback) {

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    const payload = { 'key': key };

    JeeWebSDK.removeLocal(uuid, JSON.stringify(payload) );
}

JeeWeb.removeAllLocal = function (callback) {

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    JeeWebSDK.removeAllLocal(uuid);
}


JeeWeb.get = function (key, callback) {

    const fn = function (res) {
        const result = res.result;
        if (result) {
            try {
                const parsedObject = JSON.parse(result);
                res.result = parsedObject;
            } catch (error) {
                JeeWebSDK.log(error);
            }
        }
        callback(res);
    }

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, fn);
    const payload = { 'key': key };

    JeeWebSDK.get(uuid, JSON.stringify(payload));
}

JeeWeb.set = function (key, value, callback) {

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    let stringValue = JSON.stringify(value);
    const payload = { 'key': key, 'value': stringValue };

    JeeWebSDK.set( uuid, JSON.stringify(payload) );
}

JeeWeb.getAll = function (callback) {
    const fn = function (res) {
        const result = res.result;
        if (result) {
            const parsedObject = {};
            for (const key in result) {
                if (result.hasOwnProperty(key)) {
                    try {
                        parsedObject[key] = JSON.parse(result[key]);
                    } catch (error) {
                        JeeWebSDK.log(error);
                    }
                }
            }
            res.result = parsedObject;
        }
        callback(res);
    }


    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, fn);
    JeeWebSDK.getAll(uuid );
}

JeeWeb.remove = function (key, callback) {

    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    const payload = { 'key': key };

    JeeWebSDK.remove( uuid, JSON.stringify(payload));
}



JeeWeb.removeAll = function (callback) {
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, callback);
    JeeWebSDK.removeAll( uuid );
}
//-----K-V存储------







// 注册生命周期显示
JeeWeb.onShow = function (obj) {
    console.log("注册生命周期显示", obj);
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, obj);
    JeeWebSDK.onShow(uuid);
}
// 注册生命周期隐藏
JeeWeb.onHide = function (obj) {
    console.log("注册生命周期隐藏", obj);
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, obj);
    JeeWebSDK.onHide(uuid);
}
// 注册生命周期显示
JeeWeb.offShow = function (obj) {
    console.log("反注册生命周期显示", obj);
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, obj);
    JeeWebSDK.onShow(uuid);
}
// 注册生命周期隐藏
JeeWeb.offHide = function (obj) {
    console.log("反注册生命周期隐藏", obj);
    const uuid = JeeWebSDK.uuid();
    JeeWebSDK.FUNCTION_MAP.set(uuid, obj);
    JeeWebSDK.onHide(uuid);
}

